program representations; { 1993.6.23 by Masaaki Wada }


uses
	str, event, picture, nData, rData, small_gl2p, slList, repTree;


var
	textRect: Rect;
	fin, fout: text;
	iname, oname, name: string;
	fileOutPut: boolean;
	interrupted: boolean;
	c: char;

	s, nds: string;
	nd: nData;
	rd: rData;
	sls: array[1..maxNumStrips] of sl;
	p: integer;
	rt: repTree;



procedure wr (s: string);
	begin
		write(s);
		if fileOutPut then
			write(fout, s)
	end;



procedure wrln (s: string);
	begin
		writeln(s);
		if fileOutPut then
			writeln(fout, s)
	end;



function rep2str: string;

	var
		s: string;
		i: integer;
		g, h: sl;
		commutative: boolean;

	begin
		s := '';
		commutative := true;
		with rd do
			begin
				if numT > 0 then
					h := sls[Ts[1]]
				else
					h := sls[Ns[1]];
				if numT > 0 then
					begin
						s := 'Top[';
						for i := 1 to numT do
							begin
								g := sls[Ts[i]];
								s := concat(s, gl2str(g));
								if not glEQ(g, h) then
									commutative := false
							end;
						s := concat(s, '] ')
					end;
				for i := 1 to numN do
					begin
						g := sls[Ns[i]];
						s := concat(s, gl2str(g));
						if not glEQ(g, h) then
							commutative := false
					end;
				if numB > 0 then
					begin
						s := concat(s, ' Bottom[');
						for i := 1 to numB do
							s := concat(s, gl2str(sls[Bs[i]]));
						s := concat(s, ']')
					end
			end;
		if commutative then
			rep2str := concat('*', s)
		else
			rep2str := concat(' ', s)
	end;


function longitude: sl;

	var
		slwork: array[1..maxNumStrips] of sl;
		t, longtd, g: sl;
		i: integer;

	function cMat (f: sl): sl; { f = cMat.f.cMat^-1 }
		var
			list: slList;
			j: longint;
		begin
			list := rt.itsSlList;
			for j := 0 to list.numOfItems - 1 do
				begin
					g := list.getMat(j);
					if glEQ(slConjL(g, t), f) then
						begin
							cMat := g;
							exit(cMat)
						end
				end;
			writeln('Error[longitude]')
		end;

	begin
		t := rt.rtRec(0).matrix;
		glSet(1, 0, 0, 1, longtd);
		with rd do
			for i := 1 to numRR do
				with rr[i] do
					case knd of
						genKnd: 
							slwork[out] := cMat(sls[out]);
						posKnd: 
							begin
								g := slConjL(slwork[in1], t);
								slwork[out] := glProd(glProd(g, slwork[in2]), slInv(t))
							end;
						negKnd: 
							begin
								g := slConjL(slwork[in1], slInv(t));
								slwork[out] := glProd(glProd(g, slwork[in2]), t)
							end;
						chkKnd: 
							begin
								g := glProd(slInv(slwork[in1]), slwork[in2]);
								longtd := glProd(g, longtd)
							end;
						stpKnd: 
							; { do nothing }
					end;
		longitude := longtd
	end;



procedure findReps;

	var
		nn, depth: integer;
		nns: array[1..maxNumStrips] of integer;
		first_time: boolean;
		rtr: rtRecord;

	begin
		nn := 0;
		first_time := true;
		depth := 1;
		with rd do
			while depth >= 1 do
				with rr[depth] do
					case knd of
						genKnd: 
							if first_time then
								begin
									nns[depth] := nn;
									rtr := rt.rtRec(nn);
									sls[out] := rtr.matrix;
									nn := rtr.vnext;
									depth := depth + 1
								end
							else { if not first_time then }
								begin
									rtr := rt.rtRec(nns[depth]);
									if rtr.hnext = no_more then
										depth := prevGen
									else
										begin
											nns[depth] := rtr.hnext;
											rtr := rt.rtRec(nns[depth]);
											sls[out] := rtr.matrix;
											nn := rtr.vnext;
											first_time := true;
											depth := depth + 1
										end
								end;
						posKnd: 
							begin
								sls[out] := slConjL(sls[in1], sls[in2]);
								depth := depth + 1
							end;
						negKnd: 
							begin
								sls[out] := slConjR(sls[in1], sls[in2]);
								depth := depth + 1
							end;
						chkKnd: 
							if glEQ(sls[in1], sls[in2]) then
								depth := depth + 1
							else
								begin
									first_time := false;
									depth := prevGen
								end;
						stpKnd: { a rep found!!! }
							begin
								wr(rep2str);
								if (numT = 0) and (numB = 0) then
									begin
										wr('  l=');
										wr(gl2str(longitude))
									end;
								wrln('');
								first_time := false;
								depth := prevGen
							end
					end
	end;




begin { of main }
	textRect := screenBits.bounds;
	with textRect do
		begin
			top := top + 40;
			left := left + 5;
			bottom := bottom - 5;
			right := right - 5
		end;
	SetTextRect(textRect);
	ShowText;

	iname := OldFileName('Input n-data file:');
	if iname = '' then
		begin
			writeln('Cancelled.');
			Halt
		end;
	reset(fin, iname);

	name := iname;
	while pos(':', name) > 0 do
		delete(name, 1, pos(':', name));
	if length(name) > 6 then
		if copy(name, length(name) - 5, 6) = '.ndata' then
			name := copy(name, 1, length(name) - 6);
	oname := NewFileName('Output file:', concat(name, '.reps'));
	fileOutPut := (oname <> '');
	if fileOutPut then
		rewrite(fout, oname);

	interrupted := false;

	while not (eof(fin) or interrupted) do
		begin
			readln(fin, s);
			nds := strGetW(s, all - [':', ';']);
			if s <> '' then
				begin
					delete(s, 1, 1);
					wrln(s)
				end;
			nDataFromStr(nd, nds);
			wrln(nDataToStr(nd));
			if nd.error then
				Leave;
			nDataToRData(nd, rd);
			wrln(rDataToStr(rd));
			wrln('');

			readln(fin, s); { read in primes }
			strSkip(s, [' ']);
			while s <> '' do
				begin
					p := strGetLong(s);
					strSkip(s, [' ']);
					wrln(concat('SL_2(', long2str(p), ')-representations.'));

					new(rt);
					rt.init(p);
					while rt.moreClass do
						findReps;
					rt.free;

					if keypressed(c) then
						if cmdKeyDown and (c = '.') then
							begin
								interrupted := true;
								Leave
							end;
					wrln('')
				end
		end;

	if interrupted then
		wrln('Interrupted.')
	else
		wrln('End of file.');
	if fileOutPut then
		close(fout);
	close(fin)
end.