unit date;   { programmed by Masaaki Wada, December 21, 1990 }

interface

function date2day (y, m, d: integer): longint;
procedure day2date (day: longint; var y, m, d: integer);

function dayOfWeek (day: longint): integer;   { 0..6 = Sunday..Satarday }
function dayOfWeek2str (day: longint): string;
function month2str (month: integer): string;


implementation


function year2days (y: longint): longint;
	begin
		year2days := y * 365 + y div 4 - y div 100 + y div 400
	end;


function date2day (y, m, d: integer): longint;
	var
		m3: longint;
	begin
		if m <= 2 then
			begin
				m3 := m + 9;
				y := y - 1
			end
		else
			m3 := m - 3;
		date2day := year2days(y) + round(m3 * 30.6) + d - 306
	end;


procedure day2date (day: longint; var y, m, d: integer);
	var
		m3: longint;
	begin
		day := day + 306;
		y := day div 365 + 1;
		repeat
			y := y - 1;
			d := day - year2days(y)
		until d > 0;
		m3 := trunc((d - 0.5) / 30.6);
		d := d - round(m3 * 30.6);
		if m3 > 9 then
			begin
				m := m3 - 9;
				y := y + 1
			end
		else
			m := m3 + 3
	end;


function dayOfWeek (day: longint): integer;   { 0..6 = Sunday..Satarday }
	begin
		dayOfWeek := day mod 7
	end;


function dayOfWeek2str (day: longint): string;
	begin
		case dayOfWeek(day) of
			0: 
				dayOfWeek2str := 'Sunday';
			1: 
				dayOfWeek2str := 'Monday';
			2: 
				dayOfWeek2str := 'Tuesday';
			3: 
				dayOfWeek2str := 'Wednesday';
			4: 
				dayOfWeek2str := 'Thursday';
			5: 
				dayOfWeek2str := 'Friday';
			6: 
				dayOfWeek2str := 'Satarday'
		end
	end;


function month2str (month: integer): string;
	begin
		case month of
			1: 
				month2str := 'January';
			2: 
				month2str := 'February';
			3: 
				month2str := 'March';
			4: 
				month2str := 'April';
			5: 
				month2str := 'May';
			6: 
				month2str := 'June';
			7: 
				month2str := 'July';
			8: 
				month2str := 'August';
			9: 
				month2str := 'September';
			10: 
				month2str := 'October';
			11: 
				month2str := 'November';
			12: 
				month2str := 'December'
		end
	end;


end.