unit gl2p;   { 1993.6.10  programmed by Masaaki Wada }

interface

uses
	str, fp;

type
	gl = record
			a, b, c, d: integer
		end;
	sl = gl;

procedure glInit (p: integer);
procedure glSet (a, b, c, d: integer; var g: gl);
procedure glProd (g1, g2: gl; var h: gl);
procedure slInv (g: sl; var h: sl);
function gl2str (g: gl): string;



implementation


procedure glInit (p: integer);
	begin
		fpInit(p);
		fpLongStr(true);
	end;


procedure glSet (a, b, c, d: integer; var g: gl);
	begin
		g.a := fpNormalize(a);
		g.b := fpNormalize(b);
		g.c := fpNormalize(c);
		g.d := fpNormalize(d)
	end;


procedure glProd (g1, g2: gl; var h: gl);
	begin
		h.a := fpSum(fpProd(g1.a, g2.a), fpProd(g1.b, g2.c));
		h.b := fpSum(fpProd(g1.a, g2.b), fpProd(g1.b, g2.d));
		h.c := fpSum(fpProd(g1.c, g2.a), fpProd(g1.d, g2.c));
		h.d := fpSum(fpProd(g1.c, g2.b), fpProd(g1.d, g2.d))
	end;


procedure slInv (g: sl; var h: sl);
	begin
		h.a := g.d;
		h.b := fpNeg(g.b);
		h.c := fpNeg(g.c);
		h.d := g.a
	end;


function gl2str (g: gl): string;
	begin
		with g do
			gl2str := concat('(', fp2str(a), ',', fp2str(b), ';', fp2str(c), ',', fp2str(d), ')')
	end;


end.